<?php
/*
Name: CodeIgniter/Ext JS 4 Database Admin Utility
Description: Define which URL parameters should be captured, and then creates a shortcode so that the value can be used in your Posts. 
Author: gsmith
Version: 1.0
Author URI: dhttp://www.z-car.com/blog/2012/02/03/atabase-admin-controller-for-code-igniter-and-ext-js-4
*/
if (!defined('BASEPATH')) exit('No direct script access allowed');

class TableAdmin extends CI_Controller {
    public 
    function index() {

        
        if (isset($_GET['table']) and strlen($_GET['table']) > 0) {
            $data['tablename'] = $_GET['table'];
            $data['database'] = $_GET['database'];
            $this->load->database($data['database']);
            $primarykeyinfo = $this->getPrimary($data['database'], $data['tablename']);
            $data['primarykey'] = $primarykeyinfo['primary_key'];
            
            if ($primarykeyinfo['auto_increment'] == 'auto_increment') {
                $data['auto_increment'] = $primarykeyinfo['primary_key'];
            } else {
                $data['auto_increment'] = 0;
            }
            $data['fieldinfo'] = $this->db->field_data($data['tablename']);
            $this->load->view('tableadmin_view', $data);
        } else {
            $this->load->view('tableadmin_view_port');
        }
    }
    public 
    function read() {
        
        $data['tablename'] = $_GET['table'];
        $data['database'] = $_GET['database'];
        $this->load->database($data['database']);
        $data['fields'] = $this->db->list_fields($data['tablename']);
        $query = $this->db->query("SHOW TABLE STATUS like '" . $data['tablename'] . "'");
        $totalCount = $query->row()->Rows;
        $query = $this->db->query("select * from " . $data['tablename'] . " order by " . $data['fields'][0] . " desc limit " . $_GET['start'] . "," . $_GET['limit'] . "");
        $result = $query->result();
        $output = '{"method":"GET","success":"true","totalCount":' . $totalCount . ',';
        $output.= '"records":[';
        foreach ($result as $row) {
            $output.= '{';
            foreach ($data['fields'] as $field) {
                $output.= '"' . $field . '":' . json_encode($row->$field) . ',';
            }
            $output = trim($output, ',');
            $output.= '},';
        }
        $output = trim($output, ',');
        $output.= ']}';
        echo $output;
    }
    public 
    function destroy() {

        $data['tablename'] = $_GET['table'];
        $data['database'] = $_GET['database'];
        $this->load->database($data['database']);
        $jsondata = file_get_contents("php://input");
        $jsonArray = json_decode($jsondata, true);
        
        if (sizeof($jsonArray['records']) > 1) {
            foreach ($jsonArray['records'] as $one) {
                foreach ($one as $key => $element) {
                    $query = "delete  from " . $data['tablename'] . "  where " . $key . "=" . $element;
                    $q = $this->db->query($query);
                }
            }
        } else {
            foreach ($jsonArray['records'] as $key => $element) {
                $query = "delete  from " . $data['tablename'] . "  where " . $key . "=" . $element;
                $q = $this->db->query($query);
            }
        }
        $response = array('success' => 'true');
        echo json_encode($response);
    }
    
    function update() {

        $data['tablename'] = $_GET['table'];
        $data['database'] = $_GET['database'];
        $this->load->database($data['database']);
        $jsondata = file_get_contents("php://input");
        $jsonArray = json_decode($jsondata, true);
        
        if (count($jsonArray['records']) <> count($jsonArray['records'], COUNT_RECURSIVE)) {
            foreach ($jsonArray['records'] as $one) {
                $set = ' set ';
                $where = ' where ';
                foreach ($one as $key => $element) {
                    $primarykeyinfo = $this->getPrimary($data['database'], $data['tablename']);
                    
                    if ($key == $primarykeyinfo['primary_key']) {
                        $where.= $key . '="' . $element . '"';
                    } else {
                        $set.= $key . '="' . $element . '",';
                    }
                }
                $set = trim($set, ',');
                $query = 'update ' . $_GET['table'] . $set . $where;
                $q = $this->db->query($query);
            }
        } else {
            $set = ' set ';
            $where = ' where ';
            foreach ($jsonArray['records'] as $key => $element) {
                $primarykeyinfo = $this->getPrimary($data['database'], $data['tablename']);
                
                if ($key == $primarykeyinfo['primary_key']) {
                    $where.= $key . '="' . $element . '"';
                } else {
                    $set.= $key . '="' . $element . '",';
                }
            }
            $set = trim($set, ',');
            $query = 'update ' . $data['tablename'] . $set . $where;
            $q = $this->db->query($query);
        }
        $response = array('success' => 'true');
        $jsonArray['success'] = "true";
        echo json_encode($response);
    }
    public 
    function create() {

        $data['tablename'] = $_GET['table'];
        $data['database'] = $_GET['database'];
        $this->load->database($data['database']);
        $jsondata = file_get_contents("php://input");
        $jsonArray = json_decode($jsondata, true);
        $this->db->insert($_GET['table'], $jsonArray['records']);
        echo $this->db->insert_id();
    }
    public 
    function tableInfo() {

        $data['tablename'] = $_GET['table'];
        $data['database'] = $_GET['database'];
        $this->load->database($data['database']);
        $fields = $this->db->field_data($data['table']);
        foreach ($fields as $field) {
            print_r($field);
            echo $field->name;
            echo $field->type;
            echo $field->max_length;
            echo $field->primary_key . '<br>';
        }
    }
    public
    function TestView(){
        $this->load->view('tableadmin_view_port');
    }
    public 
    function databaseInfo() {

        
        if ($_GET['node'] == 'root') {
            include ('./application/config/database.php');
            $output = "{\"text\":\".\",\"children\": [";
            foreach ($db as $key => $database) {
                $output.= "{id:'root\/" . $key . "',databasename:'" . $key . "',host : '" . $database['hostname'] . "',database:'" . $database['database'] . "'},";
            }
            $output = trim($output, ',');
            $output.= "]}";
            echo $output;
            die();
        }
        $config = $_GET['node'];
        $config = ltrim($config, 'root/');
        $this->load->database($config);
        $alltables = $this->db->list_tables();
        $output = "{\"text\":\".\",\"children\": [";
        foreach ($alltables as $table) {
            $output.= "{id:'" . $_GET['node'] . "\/" . $table . "',table:'" . $table . "',leaf:true,databasename: '" . $config . "'},";
        }
        $output = trim($output, ',');
        $output.= "]}";
        echo $output;
    }
    private 
    function getPrimary($scheme, $table) {

        $query = $this->db->query("SELECT COLUMN_NAME,EXTRA
        FROM `information_schema`.`COLUMNS`
        WHERE (`TABLE_SCHEMA` = '" . $this->db->database . "')
          AND (`TABLE_NAME` = '" . $table . "')
          AND (`COLUMN_KEY` = 'PRI')");
        $value['primary_key'] = $query->row()->COLUMN_NAME;
        $value['auto_increment'] = $query->row()->EXTRA;
        return $value;
    }
}
