<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=us-ascii">

    <title><?php echo $tablename;?></title>
    <link rel="stylesheet" type="text/css" href="http://dev.sencha.com/deploy/ext-4.0.7-gpl/resources/css/ext-all.css">
    <script type="text/javascript" src="http://dev.sencha.com/deploy/ext-4.0.7-gpl/ext-all-debug.js">
</script>
    <script type="text/javascript">
    Ext.define('TemplateModel', {
        extend: 'Ext.data.Model',
         idProperty: '<?php echo $primarykey ?>',
        fields: [ <?php foreach($fieldinfo as $field) { ?> {
                name: '<?php echo $field->name; ?>',
                <?php
                switch ($field->type) {
                case 'int':
                    echo "type: 'integer',";
                    break;
                case 'varchar':
                    echo "type: 'string',";
                    break;
                } ?>

                mapping : '<?php echo $field->name?>'
            }, <?php
        } ?> ]
    });


    Ext.define('TableAdmin.store.TemplateJsonStore', {
        extend: 'Ext.data.Store',
        autoLoad: true,
        autoSync: true,
                    listeners : {
                        write : function(store, action, result, res, rs) {
                            store.load();
                        }} ,        
        model: 'TemplateModel',
        constructor: function(cfg) {
            var me = this;
            cfg = cfg || {};

            me.callParent([Ext.apply({
                storeId: 'TemplateJsonStore',
                proxy: {
                    type: 'ajax',

                    api: {
                        read: 'tableadmin/read?table=<?php echo $tablename;?>&database=<?php echo $database;?>',
                        create: 'tableadmin/create?table=<?php echo $tablename;?>&database=<?php echo $database;?>',
                        update: 'tableadmin/update?table=<?php echo $tablename;?>&database=<?php echo $database;?>',
                        destroy: 'tableadmin/destroy?table=<?php echo $tablename;?>&database=<?php echo $database;?>'
                    },
                    reader: {
                        type: 'json',
                        idProperty: '<?php echo $primarykey ?>',
                        root: 'records',
                        totalProperty: 'totalCount'
                    },
                    writer: {
                        type: 'json',
                        idProperty: '<?php echo $primarykey ?>',
                        listful: true,
                        writeAllFields: false,
                        root: 'records'
                    }
                }
            }, cfg)]);
        }
    });

    Ext.define('TableAdmin.view.ui.Viewport', {
        extend: 'Ext.container.Viewport',

        autoScroll:true,
        initComponent: function() {
            var me = this;

            Ext.applyIf(me, {
                items: [{
                    xtype: 'gridpanel',
                    title: '<?php echo $database;?> - <?php echo $tablename;?>',
                    store: 'TemplateJsonStore',

                    columns: [ <?php
                    $output = '';
                    foreach($fieldinfo as $field) {
                        $output.= '{';
                        if ($field -> type = 'integer') {
                            $output.= 'xtype :"numbercolumn", format: "0", width:50,';
                        }
                        if ($field -> type = 'varchar') {
                            $output.= 'xtype :"gridcolumn",flex:1, ';
                        }
                        $output.= 'dataIndex: "'.$field -> name.'",';
                        $output.= 'text: "'.$field -> name.'",';
                        if ($auto_increment!==$field->name){
                            if (($field -> type == 'integer')) $output.='editor:"numberfield"';
                            if (($field -> type == 'varchar')) $output.='editor:"textfield"';
                        }
                        $output.= '},';

                    }
                    $output = trim($output, ',');
                    echo $output; ?>

                    ],
                    viewConfig: {

                    },
                    plugins: [
                    Ext.create('Ext.grid.plugin.CellEditing', {

                    })],
                    dockedItems: [{
            dock: 'bottom',
            xtype: 'pagingtoolbar',
            store: 'TemplateJsonStore',
            displayInfo: true,
            displayMsg: 'Display records [{0}] - [{1}] of {2}',
            emptyMsg: 'No records to display'
                    },{
                        dock:'top',
                        xtype:'toolbar',
                        items:[{
                    xtype: 'button',
                    text: 'Add Record',
                    cls: 'x-btn-text-icon x-btn-outline',
                    columns: 2,
                    width: 113,
                    listeners: {
                        'click': {
                            fn: function() {
                                        this.ownerCt.ownerCt.store.autoSync=false;
                                        this.ownerCt.ownerCt.store.insert(0,new TemplateModel());
                                        this.ownerCt.ownerCt.editingPlugin.startEditByPosition({row: 0, column: <?php if ($auto_increment<>0) {echo '1';} else {echo '0';}?>});
                                        this.ownerCt.ownerCt.store.autoSync=true;
                            }
                        }
                    }
                },{
                    xtype: 'button',
                    text: 'Delete Record',
                    cls: 'x-btn-text-icon x-btn-outline',
                    columns: 2,
                    width: 113,
                    listeners: {
                        'click': {
                            fn: function() {
                                var t = this.ownerCt.ownerCt.getSelectionModel().getSelection();
                                if (!t) {
                                    return;
                                }

                                Ext.MessageBox.confirm('Confirm', 'Are you sure you want to do that?', function(btn) {
                                    if (btn == 'yes') {
                                        this.ownerCt.ownerCt.store.remove(t[0]);
                                    }
                                },this);
                            }
                        }
                    }
                }]
                    }
                      ]
                }]
            });

            me.callParent(arguments);
        }
    });

    Ext.define('TableAdmin.view.Viewport', {
        extend: 'TableAdmin.view.ui.Viewport',

        initComponent: function() {
            var me = this;
            me.callParent(arguments);
        }
    });


    Ext.Loader.setConfig({
        enabled: true
    });

    Ext.application({
        name: 'TableAdmin',

        stores: ['TemplateJsonStore'],

        launch: function() {
            Ext.QuickTips.init();

            var cmp1 = Ext.create('TableAdmin.view.Viewport', {
                renderTo: Ext.getBody()
            });
            cmp1.show();
        }
    });
    
</script>
</head>

<body>
</body>
</html>
