<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN">

<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=us-ascii">

    <title>Code Igniter Database Admin for Ext JS 4</title>
    <link rel="stylesheet" type="text/css" href="http://dev.sencha.com/deploy/ext-4.0.7-gpl/resources/css/ext-all.css">
    <script type="text/javascript" src="http://dev.sencha.com/deploy/ext-4.0.7-gpl/ext-all-debug.js">
</script>
<script type="text/javascript">

Ext.require(['Ext.data.*', 'Ext.grid.*', 'Ext.tree.*']);

Ext.define('Task', {
    extend: 'Ext.data.Model',

    fields: [{
        name: 'databasename',
        type: 'string'
    }, {
        name: 'host',
        type: 'string'
    }, {
        name: 'database',
        type: 'string'
    }, {
        name: 'table',
        type: 'string'
    }]
});

var store = Ext.create('Ext.data.TreeStore', {
    model: 'Task',
    root: {
        text: 'Database',
        id: 'root'
    },
    proxy: {
        type: 'ajax',

        url: 'tableadmin/databaseinfo'
    },
    folderSort: true
});






Ext.define('MyViewportUi', {
    extend: 'Ext.Container',
    height: 850,
    layout: 'border',
    itemId: 21,
    autoHeight: true,
    autoWidth: true,
    width: 1300,
    title: 'Navigation',
    initComponent: function() {
        this.items = [{
            xtype: 'treepanel',
            region: 'west',
            id: 'west',



            title: 'Code Igniter Databases',
            width: 600,
            height: 300,

            collapsible: true,

            useArrows: true,
            rootVisible: false,
            listeners: {
                itemclick: function(view, rec, item, index, eventObj) {
                    if (rec.get('table').length > 0) {

                        var desturl = "tableadmin?database=" + rec.get('databasename') + "&table=" + rec.get('table');
                        Ext.getCmp('tableinfo').update('<iframe frameborder="0" src="tableadmin?database=' + rec.get('databasename') + '&table=' + rec.get('table') + '" Width="100%" Height="100%"></iframe>');
                    }
                }
            },
            store: store,
            multiSelect: true,
            singleExpand: true,
            //the 'columns' property is now 'headers'
            columns: [{
                xtype: 'treecolumn',
                //this is so we know which column will show the tree
                text: 'Config Name',
                flex: 2,
                dataIndex: 'databasename'
            }, {
                text: 'Host Name',
                dataIndex: 'host',
                flex: 1
            }, {
                text: 'Database Name',
                dataIndex: 'database',
                flex: 2
            }, {
                text: 'Table',
                dataIndex: 'table',
                flex: 3
            }]

        },

        {
            xtype: 'panel',
            region: 'center',
            //autoHeight:true,
            //layout:'fit',
            id: 'tableinfo'
        }];


        MyViewportUi.superclass.initComponent.call(this);
    }
});


MyViewport = Ext.extend(MyViewportUi, {
    initComponent: function() {
        MyViewport.superclass.initComponent.call(this);
    }
});


Ext.onReady(function() {

    Ext.QuickTips.init();
    var cmp1 = Ext.create('MyViewport', {
        renderTo: Ext.getBody()
    });
    cmp1.show();
});


</script>
</head>

<body>
</body>
</html>
